{*?template charset=utf-8?*}

{* Default object admin view template *}
{default with_children=true()
         is_editable=true()
	 is_standalone=true()}
{let page_limit=15
     list_count=and($with_children,fetch('content','list_count',hash(parent_node_id,$node.node_id,depth_operator,eq)))}
{default content_object=$node.object
         content_version=$node.contentobject_version_object
         node_name=$node.name|wash}

{section show=$is_standalone}
<form name="fullview" method="post" action={"content/action"|ezurl}>
{/section}


<div class="object">
<h1>{$node_name}</h1>
<input type="hidden" name="TopLevelNode" value="{$content_object.main_node_id}" />

    {default validation=false()}
    {section show=$validation}
      {include name=Validation uri='design:content/collectedinfo_validation.tpl' validation=$validation collection_attributes=$collection_attributes}
    {/section}
    {/default}

<table cellspacing="10">
    {section show=$content_object.data_map.title2.has_content}
        <tr><td colspan="3">
        <div class="block">
        <label>Additional title</label>
    	<p class="box">{attribute_view_gui attribute=$content_object.data_map.title2}</p>
        </div></td></tr>
    {/section}
    <tr><td valign="top">
          <div class="block">
          <label>Author(s)</label>
          <p class="box">{attribute_view_gui attribute=$content_object.data_map.author}</p>
          </div></td><td valign="top">
    <div class="block">
         <label>Year</label>
         <p class="box">{attribute_view_gui attribute=$content_object.data_map.year}</p>
    </div></td><td valign="top">
    <div class="block">
         <label>Length</label>
         <p class="box">{attribute_view_gui attribute=$content_object.data_map.length}</p>
    </div></td></tr>
</table>

{*
    {section name=ContentObjectAttribute loop=$content_version.contentobject_attributes}
    <div class="block">
        <label>{$ContentObjectAttribute:item.contentclass_attribute.name|wash}</label>
    	<p class="box">{attribute_view_gui attribute=$ContentObjectAttribute:item}</p>
    </div>
    {/section}
*}

</div>

{* //////////////////////// TABS //////////////////////////// *}

<link rel="stylesheet" href="/design/_famu/stylesheets/flora/flora.tabs.css" type="text/css" media="screen" title="Flora (Default)">
<script type="text/javascript" src="http://dev.jquery.com/view/trunk/plugins/ui/ui.tabs.js"></script>

        <div id="zalozky" class="flora">
            <ul>
                <li><a href="#fragment-1"><span>Stream</span></a></li>
                <li><a href="#fragment-2"><span>Synopsis</span></a></li>
                <li><a href="#fragment-3"><span>Info</span></a></li>
                <li><a href="#fragment-4"><span>Related</span></a></li>
                <li><a href="#fragment-5"><span>Comments</span></a></li>
            </ul>
            <div id="fragment-1">
                         <div class="block">
                         <label>Play</label><br />
    	                 {*<p class="box">{attribute_view_gui attribute=$content_object.data_map.streams}</p>*}
                         {foreach $content_object.data_map.streams.content.relation_list as $element}
                            {def $stream=fetch( 'content', 'node', hash( 'node_id', $element.node_id ) )}
                            <a href=http://media.visions.cz/vasulka/{$stream.object.data_map.file1.content}>
                            {attribute_view_gui attribute=$stream.object.data_map.still1 image_class=small}
                            {attribute_view_gui attribute=$stream.object.data_map.still2 image_class=small}
                            {attribute_view_gui attribute=$stream.object.data_map.still3 image_class=small}
                            {attribute_view_gui attribute=$stream.object.data_map.still4 image_class=small}
                            {attribute_view_gui attribute=$stream.object.data_map.still5 image_class=small}
                            {attribute_view_gui attribute=$stream.object.data_map.still6 image_class=small}
                            {attribute_view_gui attribute=$stream.object.data_map.still7 image_class=small}
                            </a>
                            {delimiter}<br /> {/delimiter}
                         {/foreach}
                         </div>
            </div>
            <div id="fragment-2">
                        <div class="block">
                        <label>Synopsis</label>
                 	<p class="box">{attribute_view_gui attribute=$content_object.data_map.synopsis}</p>
                         </div>
            </div>
            <div id="fragment-3">
                         <div class="block">
                         <label>Persons involved</label>
    	                 <p class="box">{attribute_view_gui attribute=$content_object.data_map.persons}</p>
                         <label>Type of work</label>
    	                 <p class="box">{attribute_view_gui attribute=$content_object.data_map.type}</p>
                         <label>Original carrier</label>
    	                 <p class="box">{attribute_view_gui attribute=$content_object.data_map.medium}</p>
                         <label>Technique</label>
    	                 <p class="box">{attribute_view_gui attribute=$content_object.data_map.technique}</p>
                         <label>Copyright holder</label>
    	                 <p class="box">{attribute_view_gui attribute=$content_object.data_map.copyright}</p>
                         </div>
            </div>
            <div id="fragment-4">
                        <div class="block">
                        <label>Lax relation</label>
                        {def $related_objects=fetch( 'content', 'related_objects', hash( 'object_id', $content_object.id ) )}
                        {foreach $related_objects as $object}
                        <a href={$object.main_node.url_alias|ezurl}> {$object.name|wash}</a>
                        {delimiter}, {/delimiter}
                        {/foreach}
                        <br />
                        <label>Nested objects</label>
                        {def $children=fetch('content','list',hash(parent_node_id,$node.node_id,sort_by,$node.sort_array,depth_operator,eq))}
                        {foreach $children as $childnode}
                        <a href={$childnode.object.main_node.url_alias|ezurl}> {$childnode.object.name|wash}</a>
                        {delimiter}, {/delimiter}
                        {/foreach}
                        </div>
            </div>
            <div id="fragment-5">
                        <div class="block">
                        <label>Versions</label>
{def $versions=fetch( 'content', 'version_list', hash( 'contentobject', $node.object ) )}
 
{* Loop through all versions and display their names. *}
{foreach $versions as $version}
{$version.version} <a href={$version.creator.main_node.url_alias|ezurl}>{$version.creator.name}</a> {$version.modified|datetime( 'custom', '%h:%i %a %d %F %Y' )}<br />
{/foreach}
                 
                        <br />
                        <label>Comments</label>
                        {*def $children=fetch('content','list',hash(parent_node_id,$node.node_id,sort_by,$node.sort_array,depth_operator,eq))}
                        {foreach $children as $childnode}
                        <a href={$childnode.object.main_node.url_alias|ezurl}> {$childnode.object.name|wash}</a>
                        {delimiter}, {/delimiter}
                        {/foreach*}
                        </div>
            </div>
        </div>




{*///////////////////////////////////////////*}




<input type="hidden" name="ContentNodeID" value="{$node.node_id}" />
<input type="hidden" name="ContentObjectID" value="{$content_object.id}" />
<input type="hidden" name="ViewMode" value="full" />

{* //////////////////////// CHILDREN //////////////////////////// *}



{section show=$is_standalone}
</form>
{/section}

{/default}
{/let}
{/default}

